/****************************************************************************/
/* T  vF SD J[hƂ̒ʐMɊւhCo								*/
/*   F SD J[hSPI [hB										*/
/*               DrvSdDmaSciItu DMAgpăNbNʐMȂB	*/
/*              Mׂ̊͂ă|[OŌĂĂ̊ CPU			*/
/*              LB												*/
/*               H8/3048  SCI0  MSB t@[XgŒʐMłȂ̂ SD	*/
/*              J[hhCoƂĂ SCI0 ƂĂB				*/
/* 쐬F 2004.09.11														*/
/* XVF 2013.09.30														*/
/* Copyright    resove														*/
/****************************************************************************/
#ifndef DRV_SD_DMA_SCI_ITU_H
#define DRV_SD_DMA_SCI_ITU_H

#ifndef	TRUE
#define TRUE	( 1 )
#endif
#ifndef	FALSE
#define FALSE	( 0 )
#endif

/********************************************************/
/* }N												*/
/********************************************************/
#define SD_INITIAL_SYNC_RATE		( 10000UL )			/* ̒ʐM[g(10Kbps) */
#define SD_MAX_SYNC_RATE			( 2000000UL )		/* ő̒ʐM[g(2Mbps) */
#define SD_BUSY_SYNC_RATE			( 100000UL )		/* busy ҂̒ʐM[g(100Kbps) */
#define SD_DRV_ERR_VAL				( 0xffff )			/* MG[̒l	*/

/* RecvSdPoll() ̖߂l */
typedef enum e_sd_poll_return
{
	SD_POLL_ERROR = 0,							/* G[	*/
	SD_POLL_CONTINUE,							/* s	*/
	SD_POLL_COMPLETE							/* 		*/
} T_SD_POLL;

/********************************************************/
/* ֐^錾											*/
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif

/********************************************************************/
/*		SPIʐM֐													*/
/********************************************************************/

void InitSdTrans( void );								/* M@\ */

unsigned short SendSdOne( char transmitData );	/* PoCgM */
unsigned short RecvSdBlock( char * receiveBuff,
							char transData,
							unsigned short len );		/* Af[^̎M */

unsigned short RecvSdKick( char * receiveBuff,
							char transData,
							unsigned short len );		/* Af[^̎M̋N */

T_SD_POLL SdDmaPoll( unsigned short * len );			/* DMAM̐i𒲂ׂ */

unsigned short SendSdBlock( char * transBuff,
							unsigned short len );		/* Af[^̑M */

unsigned short SendSdKick( char * transBuff,
							unsigned short len );		/* Af[^̑MN */

unsigned short SendSdRepeat( char transData,
							unsigned short len );		/* f[^̌JԂM */

unsigned short RepeatSdKick( char transData,
							unsigned short len );		/* f[^̌JԂM̋N */

unsigned short ChangeSdRate( unsigned long rate );		/* ʐM[g̕ύX	*/

/********************************************************************/
/*		荞݊֐												*/
/********************************************************************/
void CompleteDma0A( void );				/* DMA0A 荞(MŎgp)	*/
void CompleteDma0B( void );				/* DMA0B 荞(MŎgp)	*/
void CompleteTxi0( void );				/* Txi0 荞				*/

/********************************************************************/
/*		|[gANZX֐											*/
/********************************************************************/
/* |[g̓o͂ݒ肷	*/
void InitSdPort( void );
/* SD J[h̑}Ԃ擾	*/
short GetSdInsert( void );
/* SD J[h݋֎~Ԃ擾	*/
short GetSdProtect();
/* SD J[h̃`bvZNg ON ɂ	*/
void SetSdOnChipsel( short On );

/********************************************************************/
/*		ITU ANZX֐											*/
/********************************************************************/
/* ^C}̏ */
void InitSdWait( void );
/* w莞Ԃ̑҂ */
void SdWaitTimer( short time);


#ifdef __cplusplus
}
#endif

#endif	/* #ifndef DRV_SD_DMA_SCI_ITU_H */
