/****************************************************************************/
/* T  vF fobO@\܂Ƃ߂											*/
/*   F SCI1 ւ̕óAԌv֘ÃfobO@\܂Ƃ߂			*/
/* 쐬F 2004.10.09														*/
/* XVF 2014.02.23														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "3048F.H"
#include "DrvCpuXtal.h"
#include "DrvPort.h"
#include "DebugFunc.h"
#include "TraceOut.h"
#include "DrvSdDmaSciItu.h"

static unsigned long msCount;				/* ms ԌvpJE^	*/


/****************************************************************************/
/* T  v																	*/
/*        LED ̏														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         SCI1 ɏo͂													*/
/****************************************************************************/
void	InitLED( void )
{
	P5.DDR = 0x03;		/* P5-0,P5-1 o͂ɂ */
	P5.DR.BIT.B0 = 0;		/* LED 			*/
	P5.DR.BIT.B1 = 0;		/* LED t		*/
	return ;
}

/****************************************************************************/
/* T  v																	*/
/*        LED _łĉiv[v									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void winkLoop( void )
{
	while(1)
	{
		/* ݂ɓ_ */
		LedOnB0();
		LedOffB1();
		SdWaitTimer( 200 );
		LedOnB1();
		LedOffB0();
		SdWaitTimer( 200 );
	}
}


/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* fobOo															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        fobOo͂̏												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         SCI1 ɏo͂													*/
/****************************************************************************/
void InitDebugOut( void )
{
	unsigned char i;
	
	SCI1.SCR.BIT.TE = 0;							/* disable transmit */
	SCI1.SCR.BIT.RE = 0;							/* disable receive */
	SCI1.SMR.BIT.CKS = 0;	 						/* clock = 1/1 */

	/* BRR ݒl */
	/* 25Fbit rate =  19200bps */
	/* 12Fbit rate =  38400bps */
	/*  7Fbit rate =  62500bps ~*/
	/*  3Fbit rate = 125000bps ~*/
	SCI1.BRR = 12;
	for(i=0;i<255;i++);		 						/* wait 1bit priod */
	SCI1.SCR.BIT.TE	 = 1;							/* enable transmit */
	SCI1.SCR.BIT.RE	 = 1;							/* enable receive */
}	 

/****************************************************************************/
/* T  v																	*/
/*        HEX ŏo͂													*/
/* p[^																*/
/*        lenFo͂oCg												*/
/*        strFo͂f[^												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ̐lHEX̕ɕϊ SCI1 ɏo͂					*/
/****************************************************************************/
void debugHexOut( int len, char * str )
{

	int i = 0;
	char wk;
	for( i = 0 ; i < len; ++i)
	{
		if( (i != 0 ) && ( (i % 32) == 0 ) )
		{
			debugAChar( '\n' );						/* 32 oCgŏɉs */
		}

		/* ʌҏW */
		wk = str[i] ;								/* ASCII R[hɕϊ */
		wk >>= 4;
		if( wk > 9 )	wk = (char)((wk - 9)|0x40);
		else 			wk |= 0x30;
		debugAChar( wk );							/* ʌo	*/

		/* ʌҏW */
		wk = str[i] ;								/* ASCII R[hɕϊ */
		wk &= 0x0f;
		if( wk > 9 )	wk = (char)((wk - 9)|0x40);
		else 			wk |= 0x30;
		debugAChar( wk );							/* ʌo	*/
	}


	debugAChar( '\n' );								/* sR[h𑗐M */
}

/****************************************************************************/
/* T  v																	*/
/*        fobOplo												*/
/* p[^																*/
/*        numFo͂鐔l													*/
/*        digFo͂錅													*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ̐l𕶎ɕϊ SCI1 ɏo͂						*/
/****************************************************************************/
void debugNum( unsigned long num, int dig )
{
	int i = 0;
	unsigned long digit = 1;

	for( i = 1; i < dig; i++ )
	{
		digit *= 10UL;
	}

	for(i=0; i < dig; i++){
		debugAChar( (char)(((num / digit) % 10UL) | 0x30UL ));	/* lo	*/
		digit /= 10UL;
	}
}

/****************************************************************************/
/* T  v																	*/
/*        fobOpo												*/
/* p[^																*/
/*        strFo͂镶												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ̍Ō '\0'鎖OB								*/
/*        ŌɉsR[ho͂										*/
/****************************************************************************/
void debugTxt( char *str )
{
	int i = 0;

	for( i=0; (i < 255) && (str[i] != '\0'); ++i )
	{
		debugAChar( str[i] );
	}
}


/****************************************************************************/
/* T  v																	*/
/*        fobOpo												*/
/* p[^																*/
/*        aCharFo͂镶												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        Po͂												*/
/****************************************************************************/
void debugAChar( char aChar )
{
	while( !SCI1.SSR.BIT.TDRE );				/* wait TDR empty */
	SCI1.TDR = aChar;							/* write transmit data */
	SCI1.SSR.BIT.TDRE = 0;						/* transmit start */
}

/****************************************************************************/
/* T  v																	*/
/*        fobOp												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        ͂														*/
/*   																	*/
/*        P														*/
/****************************************************************************/
char debugGetChar( void )
{
	char wk;

	while( (!SCI1.SSR.BIT.RDRF) &&
			(!SCI1.SSR.BIT.ORER) &&
			(!SCI1.SSR.BIT.FER) &&
			(!SCI1.SSR.BIT.PER) );				/* M҂	 */

	wk = SCI1.RDR;

	SCI1.SSR.BIT.RDRF = 0;
	SCI1.SSR.BIT.ORER = 0;						/*    ORER      */
	SCI1.SSR.BIT.FER  = 0;						/*    FER       */
	SCI1.SSR.BIT.PER  = 0;						/*    PER       */
	return (char)wk;							/* Mf[^*/
}

/****************************************************************************/
/* T  v																	*/
/*        fobOpo												*/
/* p[^																*/
/*        strFo͂镶												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ̍Ō '\0'鎖OB								*/
/****************************************************************************/
void debugTimeOut(  )
{
	unsigned long time;
	StopTimeCount();
	time = GetTimeCount( NULL );					/* oߎԎ擾	*/
	debugNum((unsigned long)(time / 1000L), 5);		/* ms Pʒlo	*/
	debugTxt("ms ");								/* "ms"Pʏo		*/
	debugNum((unsigned long)(time % 1000L), 3);		/* us Pʒlo	*/
	debugTxt("us ");								/* "us"Pʏo		*/
	debugAChar( '\n' );
}
/****************************************************************************/
/* T  v																	*/
/*        _vo														*/
/* p[^																*/
/*        addr FJnAhX												*/
/*        len  F_v钷												*/
/*        pBuffF_ve													*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        16 oCgƂ̃_vWo͂ɕ\							*/
/****************************************************************************/
void dumpOut(unsigned long addr, int len, char * pBuff )
{
	int i = 0;
	for( i = 0; i < len; ++i )
	{
		if( ( i % 16 ) == 0 )
		{
			TRACE_OUT(("\n%08lx", addr + (unsigned long)i));
		}
		if( ( i % 4 ) == 0 )
		{
			TRACE_OUT((" "));
		}
			TRACE_OUT(("%02x", pBuff[i]));
	}
	TRACE_OUT(("\n"));

}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ^C}֘A																*/
/* ITU1 荞݂œĎԂ𒲂ׂ									*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
#define ITU_COUNT_4_US(n)	(unsigned short)((n)*((CPU_XTAL/4L)/1000000L)-1L)		/* us P  0.25s<= n < 16,384S /4*/
/****************************************************************************/
/* T  v																	*/
/*        ^C}̏Ȃ											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ITU1 10us  GRA RyA}b`荞݂悤ɐݒ肷	*/
/****************************************************************************/
void InitTimeCount( void )
{
	ITU1.TCNT = 0;									/* JE^NA	*/
	ITU1.TCR.BIT.CCLR = 1;							/* counte clear at GRA compare match */
	ITU1.TCR.BIT.CKEG = 0; 							/* count at upper edge */
	ITU1.TCR.BIT.TPSC = 2; 							/* internal clock / 4 */
	ITU1.GRA = ITU_COUNT_4_US(8000L);				/* 8000 usec(8ms) */
	ITU1.TIER.BIT.IMIEA = 0;						/* GRA RyA}b`荞݂ StartTimeCount()ŋ		*/
 	ITU.TSTR.BIT.STR1 = 0; 							/* ITU1 ~		*/
	msCount = 0;
}

/****************************************************************************/
/* T  v																	*/
/*        ITU1 荞														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        JE^XV												*/
/****************************************************************************/
void InterruptTimeCount( void )
{

 	ITU1.TSR.BIT.IMFA = 0;							/* 荞ݗvNA	*/
	++msCount;

}

/****************************************************************************/
/* T  v																	*/
/*        ԌvJn												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        JE^XV												*/
/****************************************************************************/
void StartTimeCount( void )
{
	msCount = 0;									/* JE^NA		*/
	ITU1.TCNT = 0;									/* JE^NA		*/
 	ITU1.TSR.BIT.IMFA = 0;							/* 荞ݗvNA	*/
	ITU1.TIER.BIT.IMIEA = 1;						/* GRA RyA}b`荞݋		*/
 	ITU.TSTR.BIT.STR1 = 1; 							/* ITU1 X^[g		*/
}

/****************************************************************************/
/* T  v																	*/
/*        Ԍv~												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        Ԍv~												*/
/****************************************************************************/
void StopTimeCount( void )
{
 	ITU.TSTR.BIT.STR1 = 0; 							/* timer stop */
	ITU1.TIER.BIT.IMIEA = 0;						/* GRA RyA}b`荞݋֎~		*/
}

/****************************************************************************/
/* T  v																	*/
/*        Ԍvʂ擾											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        us Pʂ̎														*/
/*   																	*/
/*        JE^l擾												*/
/*        StopTimeCount() Œ~Ă玞Ԃ擾邱ƁB				*/
/****************************************************************************/
unsigned long GetTimeCount( long * pMsCount )
{
	unsigned short nowTcnt;

	nowTcnt = ITU1.TCNT;
	if( pMsCount != NULL )
	{
		*pMsCount = (msCount * 8L) + (nowTcnt / 4000);				/* ms JE^ */
	}
	return msCount * 8000L + (unsigned long)(nowTcnt / 4);		/* us JE^擾	*/
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* X^bN֘A															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
extern char * START_B;						/* ZNV B ̊JnAhX */
extern unsigned long SIZE_B;				/* ZNV B ̃TCY		 */
extern char * bottomSP;						/* SP ̏I[ */
/****************************************************************************/
/* T  v																	*/
/*        X^bNgp̈ 0xff Ŗ߂								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        X^bNgpʂ𒲂ׂ邽߂炩 0xff Ŗ߂Ă			*/
/****************************************************************************/
void fillSp( void )
{
	char * curSp;
	char * nowSp;
	
	nowSp = GetSp();
	curSp = START_B + SIZE_B;
	if( (unsigned long)curSp < (unsigned long)nowSp )
	{
		while(curSp != nowSp)
		{
			*curSp = 0xff;
			++curSp;
		}
	}
}

/****************************************************************************/
/* T  v																	*/
/*        X^bNgĂȂŏ̃X^bNAhX߂			*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         炩 fillSp() 0xff Ŗ߂ĂB̌㒲ׂ	*/
/*        삳A֐s 0xff ǂ܂őĂ邩ׂB	*/
/****************************************************************************/
char * checkFreeSp( void )
{
	char * curSp;
	char * nowSp;
	
	nowSp = GetSp();									/* ݂ SP */
	curSp = START_B + SIZE_B;							/* X^bN̈̊Jnʒu */
	if( (unsigned long)curSp < (unsigned long)nowSp )
	{
		while(curSp != nowSp)
		{
			if( ((*curSp) & 0x0ff) != 0xff )	break;
			++curSp;
		}
	}
	return curSp;
}
