/****************************************************************************/
/* T  vF t@CVXe												*/
/*   F t@CVXe̕i											*/
/*          AvP[VC^tF[X(RfInterface.c)gp֐Q	*/
/* 쐬F 2005.02.06														*/
/* XVF 2005.02.06														*/
/* Copyright F	resove														*/
/****************************************************************************/
#ifndef RF_MIDDLE_H
#define RF_MIDDLE_H

#include "RfInterface.h"
#include "RfDriverInterface.h"
#include "RfControlBuff.h"

/****************************************************************************/
/* \																	*/
/****************************************************************************/

/* ړ */
typedef struct t_rf_move_info
{
	unsigned long	orgEntryAddr;			/* ̃t@CGgAhX	*/
	unsigned short	orgCluster;				/* f[^̃NX^ԍ		*/
	unsigned char	orgAttr;				/* (dir?)					*/
	unsigned char	fill;					/* gp̈					*/
	unsigned short	toCluster;				/* ړfBNg̃NX^ԍ	*/
} T_RF_MOVE_INFO;


/****************************************************************************/
/* Oϐ																	*/
/****************************************************************************/
/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/
/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
#ifdef __cplusplus
extern "C" {
#endif
/************************************************/
/* ^									*/
/************************************************/
/* Rfm ̏ */
unsigned short RfmInit( void );
/* t@CVXȅI */
unsigned short RfmConclude( void );
/* hCu擾	*/
unsigned short RfmGetDriveInfo( T_RF_DRIVE_INFO * driveInfo );
/* Ă邩ׂ */
unsigned short RfmIsInitConfirm( void );

/************************************************/
/* FAT ANZX									*/
/************************************************/
/* FAT̃`FCNA	*/
unsigned short RfmDelFatChain( unsigned short first );

/************************************************/
/* fBNgANZX							*/
/************************************************/
/* tpXfBNgNX^ʒuT */
unsigned short RfmGetDirClust( char * dirPath, unsigned short * err );
/* t@Ci[ĂfBNg̃NX^ԍ擾 */
unsigned short RfmGetParentDir( char * filePath, unsigned short * err );
/* t@C̃GgV */
unsigned short RfmCreateFileEntry( unsigned short cluster, char * flName, T_RF_FCB * pFcb );
/* fBNg̃GgV */
unsigned short RfmCreateDirEntry( unsigned short cluster, char * flPath );
/* w肳ꂽfBNg̒GgT */
unsigned long RfmFindFileEntry( unsigned short cluster, char * flName, unsigned short * pErr );
/* fBNgGgɍ폜}[N	*/
unsigned short RfmDelEntry( unsigned long addr );
/* t@C폜 */
unsigned short RfmDelFile( T_RF_DEL_FILE * pDelFileInfo );
/* fBNg폜 */
unsigned short RfmDelDir( T_RF_FCB * pFcb );
/* ړ̔z`FbN */
unsigned short RfmCheckRoots( T_RF_MOVE_INFO * pMoveInfo );
/* Ggړ */
unsigned short RfmMoveEntry( T_RF_MOVE_INFO * pMoveInfo );
/* Gg̑ύX */
unsigned short RfmUpdateAttr( T_RF_FCB * pFcb );
/* fBNgǂ */
unsigned short RfmReadDir( T_RF_FCB * pFcb, T_RF_DIR_INFO * pDirInfo );


/************************************************/
/* Open/Close									*/
/************************************************/
/* FCB ̎gpO */
unsigned short RfmInitUseFcb( T_RF_FCB * pFcb );
/* FCB ̊J */
unsigned short RfmReleaseFcb( T_RF_FCB * pFcb );
/* [gfBNg FCB  */
unsigned short RfmTakeRootInfo( T_RF_FCB * pFcb );
/* ݂t@C FCB  */
unsigned short RfmTakeExistInfo( T_RF_FCB *fcb,unsigned long entry );

/************************************************/
/* Read/Write									*/
/************************************************/
/* [h */
unsigned short RfmRead( T_RF_FCB * pFcb, char * pBuff, unsigned long * pSize );
/* [h̋N */
unsigned short RfmReadKick( T_RF_FCB * pFcb );
/* ǉ */
unsigned short RfmWriteAppend( T_RF_FCB * pFcb, char * pBuff, unsigned long * size );
/* ㏑ */
unsigned short RfmWriteOver( T_RF_FCB * pFcb, char * pBuff, unsigned long * size );
/* ǂݏʒu̕ύX */
unsigned short RfmSeek( T_RF_FCB * pFcb, long offset, unsigned short origin );
/* Iȏ */
unsigned short RfmFlush( T_RF_FCB * pFcb );

/************************************************/
/* ̑										*/
/************************************************/
/* gp FCB T */
T_RF_FCB * RfmFindFreeFcb( void );
/* gp FCB T */
T_RF_FCB * RfmFindUseFcb( void );
/* łɃI[vĂ邩ׂ */
unsigned short RfmCheckAlreadyOpen( unsigned long addr, T_RF_FCB * pFcb );



/* i[`unsigned long ɕϊ */
/* J̃[J֐ƂĂ format Ŏgp̂łނȂOɏo */
/* t@C\S̓IɍlȂ΂ȂȂ */
/* SoCgl𕪉 */
void brokenULongData( unsigned long org, char * pBuff);
/* QoCgl𕪉 */
void brokenUShortData( unsigned short org, char * pBuff);

#ifdef __cplusplus
}
#endif

#endif /* #define RF_MIDDLE_H */

