/****************************************************************************/
/* T  vF obt@TCYύX@\											*/
/*   F obt@TCYێĂ RfGenBuffSize ϐ͒ʏ const 	*/
/*          ͕s\eXgpɏƂĂۂɂ̋@\	*/
/*          ͎gpłB													*/
/* 쐬F 2011.11.20														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "TraceOut.h"
#include "TstDefine.h"
#include "TstGeneral.h"

/* ֐^錾 */
static void dispBuff( void );
static void changeBuffSize( unsigned short size );
static void buff0002( void );
static void buff0004( void );
static void buff0128( void );
static void buff0256( void );
static void buff0512( void );
static void buff1024( void );
static void buff1536( void );
static void buff2048( void );

/****************************************************************************/
/* T  v																	*/
/*        obt@TCYύXj[										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestBuffSize( void )
{
	static const T_TEST_MENU testCase[] =
	{
		{'0', "2", 			buff0002},
		{'1', "4", 			buff0004},
		{'2', "128", 		buff0128},
		{'3', "256", 		buff0256},
		{'4', "512", 		buff0512},
		{'5', "1024", 		buff1024},
		{'6', "1536",		buff1536},
		{'7', "2048",		buff2048},
		{'q', "quit",			0},

	};

	static const unsigned short testCaseNum = sizeof(testCase)/sizeof(T_TEST_MENU);

	dispBuff();
	TestMenu(testCase, testCaseNum, "Buffer size change.");				/* j[\s */

}
extern volatile unsigned short	RfGenBuffSize;
extern const unsigned short	RfGenBuffNum;

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY\												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void dispBuff( void )
{
	unsigned short saveBuffSize = 0;
	TRACE_OUT(("\nnow buffer size ( %d bytes).\n", RfGenBuffSize));
	saveBuffSize = RfGenBuffSize;
	RfGenBuffSize = 0;
	if( RfGenBuffSize != 0 )
	{
		TRACE_OUT(("buffer size can not changed!!\n"));
	}
	else
	{
		TRACE_OUT(("can change size is small %d bytes, and same.\n", RfGenBuffNum*512));
	}
	RfGenBuffSize = saveBuffSize;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 2 oCgɕύX								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff0002( void )
{
	changeBuffSize( 2 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 4 oCgɕύX								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff0004( void )
{
	changeBuffSize( 4 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 128 oCgɕύX								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff0128( void )
{
	changeBuffSize( 128 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 256 oCgɕύX								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff0256( void )
{
	changeBuffSize( 256 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 512 oCgɕύX								*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff0512( void )
{
	changeBuffSize( 512 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 1024 oCgɕύX							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff1024( void )
{
	changeBuffSize( 1024 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 1536 oCgɕύX							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff1536( void )
{
	changeBuffSize( 1536 );
}
/****************************************************************************/
/* T  v																	*/
/*        obt@TCY 2048 oCgɕύX							*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void buff2048( void )
{
	changeBuffSize( 2048 );
}

/****************************************************************************/
/* T  v																	*/
/*        obt@TCYύX												*/
/* p[^																*/
/*        sizeFobt@TCY												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void changeBuffSize( unsigned short size )
{
	if( RfGenBuffNum*512 < size )
	{
		TRACE_OUT(("prohibit setting, %d bytes.\n", size));
	}
	else
	{

		RfGenBuffSize = size;
		if( RfGenBuffSize == size )
		{
			TRACE_OUT(("buffer size changed %d bytes.\n", RfGenBuffSize));
		}
		else
		{
			TRACE_OUT(("buffer size not changed. now size is %d bytes.\n", RfGenBuffSize));
		}
	}
}


