/****************************************************************************/
/* T  vF t@CVXe mkdireXgpt@C							*/
/*   F 																*/
/* 쐬F 2005.06.11														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "TraceOut.h"
#include "TstDefine.h"

/****************************************************************************/
/* T  v																	*/
/*        fBNg쐬̃eXg											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*         																	*/
/****************************************************************************/
void TestMkDir( void )
{
	unsigned short err;
	T_RF_FCB *pFcb;
	unsigned long len;

	TEST_TITLE(("Test make directory."));
	TestReady();

	err = RfMkDir( "\\aaa" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\"\\aaa\")");
	err = RfMkDir( "\\aaa\\aaa" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\"\\aaa\\aaa\")");
	err = RfMkDir( "\\aaa\\aaa\\bbb\\" );
	CHK_ERR_CODE(err, RF_OK, "RfMkDir(\"\\aaa\\aaa\\bbb\\\")");

	pFcb = RfOpen( "\\aaa\\aaa\\..\\abc.txt", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen(\\aaa\\aaa\\..\\abc.txt)");
	if( pFcb )
	{
		len = 10UL;
		err = RfWrite( pFcb, "0123456789", &len);
		CHK_ERR_CODE(err, RF_OK, "RfWrite()");
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}

	TestConclude();
}
