/****************************************************************************/
/* T  vF ėpIȋ@\̒`												*/
/*   F ėpIȋ@\̒`												*/
/* 쐬F 2011.08.20														*/
/* XVF 2011.09.04														*/
/* Copyright	resove														*/
/****************************************************************************/
#include "RfGeneral.h"


/****************************************************************************/
/* T  v																	*/
/*        Zbg														*/
/* p[^																*/
/*        dest FZbgAhX											*/
/*        c    FZbgl												*/
/*        countFZbgoCg											*/
/* ߂l																	*/
/*        dest Ԃ														*/
/*   																	*/
/*        memset()ƓB													*/
/****************************************************************************/
void * rfMemSet( void *dest, int c, unsigned long count )
{
	unsigned long ix;
	char * target = (char*)dest;

	for( ix = 0; ix < count; ++ix )
	{
		target[ix] = (char)c;
	}
	return dest;
}

/****************************************************************************/
/* T  v																	*/
/*        Rs[														*/
/* p[^																*/
/*        dest FRs[̃|C^											*/
/*        src  FRs[̃|C^											*/
/*        countFRs[钷												*/
/* ߂l																	*/
/*        dest Ԃ														*/
/*   																	*/
/*        memcpy()ƂȂ												*/
/****************************************************************************/
void * rfMemCpy( void *dest, const void *src, unsigned long count )
{
	unsigned long ix;
	char * target = (char *)dest;
	char * orgin = (char *)src;

	for( ix = 0; ix < count; ++ix )
	{
		target[ix] = orgin[ix];
	}
	return dest;
}

/****************************************************************************/
/* T  v																	*/
/*        buf1buf2̓er										*/
/* p[^																*/
/*        buf1 Fr̃|C^											*/
/*        buf2 Fr̃|C^											*/
/*        countFr钷												*/
/* ߂l																	*/
/*        dest Ԃ														*/
/*   																	*/
/*        memcmp()ƂȂ												*/
/****************************************************************************/
int rfMemCmp( const void *buf1, const void *buf2, unsigned long count)
{
	unsigned long ix;
	char * target = (char *)buf1;
	char * orgin = (char *)buf2;
	int result = 0;

	for( ix = 0; ix < count; ++ix )
	{
		if( target[ix] < orgin[ix] )
		{
			result = -1;
			break;
		}
		if( target[ix] > orgin[ix] )
		{
			result = 1;
			break;
		}
	}
	return result;
}

/****************************************************************************/
/* T  v																	*/
/*        str ̕񒷂擾											*/
/* p[^																*/
/*        str  Fzւ̃|C^										*/
/*        len  FE̒											*/
/* ߂l																	*/
/*        '\0'܂ł̕񒷂Ԃ											*/
/*   																	*/
/*        strlen()ƂȂ̂Ƃ悤Ƃ`FbN͕̂s	*/
/*        ̂Ō͈͂wł悤ɂB								*/
/****************************************************************************/
int rfStrLen( char * str, int len )
{
	int ix;

	for( ix = 0; (str[ix]!= '\0') && (ix < len); ++ix )
	{
	}
	return ix;
}

/****************************************************************************/
/* T  v																	*/
/*        p啶ɕϊ										*/
/* p[^																*/
/*        c FϊO̕													*/
/* ߂l																	*/
/*        p͊Yp啶ԂB̑̓p[^ c ԂB	*/
/*   																	*/
/*        toupper()ƂȂ												*/
/****************************************************************************/
int rfToUpper( int c )
{

	if( (c >= (int)'a') && ( c <= (int)'z' ) )
	{
		c = c - 0x20;
	}

	return c;
}

/****************************************************************************/
/* T  v																	*/
/*        p啶ɕϊ										*/
/* p[^																*/
/*        c FϊO̕													*/
/* ߂l																	*/
/*        p啶͊YpԂB̑̓p[^ c ԂB	*/
/*   																	*/
/*        tolower()ƂȂ												*/
/****************************************************************************/
int rfToLower( int c )
{

	if( (c >= (int)'A') && ( c <= (int)'Z' ) )
	{
		c = c + 0x20;
	}

	return c;
}

/****************************************************************************/
/* T  v																	*/
/*        Rs[														*/
/* p[^																*/
/*        dist FRs[敶z											*/
/*        src  FRs[												*/
/* ߂l																	*/
/*        Rs[												*/
/*   																	*/
/*        strcpy()ƂȂ												*/
/****************************************************************************/
int rfStrCpy( char * dist,  char * src, int len )
{
	int i;

	for( i = 0; i < len; i++ )
	{
		if( src[i] == '\0' )
		{
			dist[i] = '\0';
			break;
		}
		dist[i] = src[i];
	}

	return i;
}
/****************************************************************************/
/* T  v																	*/
/*        񌋍														*/
/* p[^																*/
/*        dist     FRs[敶z										*/
/*        src      FRs[											*/
/*        distLen  Fdist ̃obt@TCY									*/
/*        len      Fő̕											*/
/* ߂l																	*/
/*        Rs[												*/
/*   																	*/
/*        dist Ɋi[Ă镶̂ src ̕AB			*/
/*        strcat()ƂȂ												*/
/****************************************************************************/
int rfStrCat( char * dist,  char * src, int distLen, int len )
{
	int i;
	int startPos;

	startPos = rfStrLen( dist, distLen );
	for( i = 0; (i < len) && ((i+startPos) < distLen); i++ )
	{
		if( src[i] == '\0' )
		{
			dist[startPos + i] = '\0';
			break;
		}
		dist[startPos + i] = src[i];
	}

	return i;
}
