/****************************************************************************/
/* T  vF fobOpo													*/
/*   F eXg̈ႢӎfobOo͂Ȃ悤ɂB	*/
/* 쐬F 2005.02.06														*/
/* XVF 2013.09.30														*/
/* Copyright    resove														*/
/****************************************************************************/
#ifndef TRACE_OUT_H
#define TRACE_OUT_H

#include "TstGeneral.h"
#include "RfGeneral.h"

/* eXg̊Jn\ */
#define TEST_TITLE(n) \
	traceOut( "\n" );		\
	traceOut( "************************************************************\n" );	\
	traceOut n;  \
	traceOut( "\n" );		\
	traceOut( "************************************************************\n" )


/* \ */
#define TRACE_OUT(n) 						\
	traceOut n



/****************************************************************/
/* eXgʂ\}N									*/ 
/* 擪 OK/NG \										*/
/****************************************************************/
/* G[R[hrꍇ̃eXgʕ\ */
#define CHK_ERR_CODE( code, cmp, str )			\
		if( (code) == (cmp) )					\
		{										\
			TRACE_OUT((" OK %s\n", str));		\
		}										\
		else									\
		{										\
			TRACE_OUT(("!NG!! %s(%04x) %s\n", GetErrCodeChar( code ), code, str));		\
		}
 
/* lr OK/NG \(l16iŕ\) */
#define CHK_CMP_HEX(num, cmp, str)				\
		if( (long)(num) == (long)(cmp) )		\
		{										\
			TRACE_OUT((" OK %s\n", str));		\
		}										\
		else									\
		{										\
			TRACE_OUT(("!NG!! %04lx vs %04lx %s\n", (long)num, (long)cmp, str));		\
		}

/* lr OK/NG \(l10iŕ\) */
#define CHK_CMP_DEC(num, cmp, str)				\
		if( (long)(num) == (long)(cmp) )		\
		{										\
			TRACE_OUT((" OK %s\n", str));		\
		}										\
		else									\
		{										\
			TRACE_OUT(("!NG!! %ld vs %ld %s\n", (long)num, (long)cmp, str));		\
		}

/* lr OK/NG \(l10iŕ\) */
#define CHK_CMP_STR(dist, src, str)				\
		if( rfMemCmp((dist), (src), (unsigned long)rfStrLen(dist, 20)) == 0 )	\
		{										\
			TRACE_OUT((" OK %s\n", str));		\
		}										\
		else									\
		{										\
			TRACE_OUT(("!NG!! %s vs %s %s\n", dist, src, str));		\
		}
/* lr OK/NG \(l10iŕ\) */
#define CHK_CMP_MEM(dist, src, len, str)			\
		if( rfMemCmp((dist), (src), (unsigned long)(len)) == 0 )	\
		{										\
			TRACE_OUT((" OK %s\n", str));		\
		}										\
		else									\
		{										\
			TRACE_OUT(("!NG!! %s\n", str));	\
		}
 

#ifdef __cplusplus
extern "C" {
#endif

void traceOut( const char * pFormat, ... );		/* tH[}bgw̕o */
void operationOut( const char * pFormat, ... );	/* ŵ߂̕o */
char operationIn( void );						/* ŵ߂ 1擾 */
unsigned short operationInStr( char * pStr, unsigned short len );/* ŵ߂̕ */

#ifdef __cplusplus
}
#endif

#endif	/* #ifndef TRACE_OUT_H */

